diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/ajax-actions.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/ajax-actions.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/ajax-actions.php	2012-12-05 18:41:06.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/ajax-actions.php	2013-07-28 15:55:53.000000000 -0500
***************
*** 10,28 ****
   * No-privilege Ajax handlers.
   */
  
! function wp_ajax_nopriv_autosave() {
! 	$id = isset( $_POST['post_ID'] ) ? (int) $_POST['post_ID'] : 0;
  
! 	if ( ! $id )
! 		wp_die( -1 );
  
! 	$message = sprintf( __('<strong>ALERT: You are logged out!</strong> Could not save draft. <a href="%s" target="_blank">Please log in again.</a>'), wp_login_url() );
! 	$x = new WP_Ajax_Response( array(
! 		'what' => 'autosave',
! 		'id' => $id,
! 		'data' => $message
! 	) );
! 	$x->send();
  }
  
  /*
--- 10,43 ----
   * No-privilege Ajax handlers.
   */
  
! /**
!  * Heartbeat API (experimental)
!  *
!  * Runs when the user is not logged in.
!  */
! function wp_ajax_nopriv_heartbeat() {
! 	$response = array();
  
! 	// screen_id is the same as $current_screen->id and the JS global 'pagenow'
! 	if ( ! empty($_POST['screen_id']) )
! 		$screen_id = sanitize_key($_POST['screen_id']);
! 	else
! 		$screen_id = 'front';
  
! 	if ( ! empty($_POST['data']) ) {
! 		$data = wp_unslash( (array) $_POST['data'] );
! 		$response = apply_filters( 'heartbeat_nopriv_received', $response, $data, $screen_id );
! 	}
! 
! 	$response = apply_filters( 'heartbeat_nopriv_send', $response, $screen_id );
! 
! 	// Allow the transport to be replaced with long-polling easily
! 	do_action( 'heartbeat_nopriv_tick', $response, $screen_id );
! 
! 	// send the current time according to the server
! 	$response['server_time'] = time();
! 
! 	wp_send_json($response);
  }
  
  /*
***************
*** 59,65 ****
  		wp_die( 0 );
  	}
  
! 	$s = stripslashes( $_GET['q'] );
  
  	$comma = _x( ',', 'tag delimiter' );
  	if ( ',' !== $comma )
--- 74,80 ----
  		wp_die( 0 );
  	}
  
! 	$s = wp_unslash( $_GET['q'] );
  
  	$comma = _x( ',', 'tag delimiter' );
  	if ( ',' !== $comma )
***************
*** 559,565 ****
  	check_ajax_referer( $action );
  	if ( !current_user_can( 'manage_categories' ) )
  		wp_die( -1 );
! 	$names = explode(',', $_POST['newcat']);
  	$x = new WP_Ajax_Response();
  	foreach ( $names as $cat_name ) {
  		$cat_name = trim($cat_name);
--- 574,580 ----
  	check_ajax_referer( $action );
  	if ( !current_user_can( 'manage_categories' ) )
  		wp_die( -1 );
! 	$names = explode(',', wp_unslash( $_POST['newcat'] ) );
  	$x = new WP_Ajax_Response();
  	foreach ( $names as $cat_name ) {
  		$cat_name = trim($cat_name);
***************
*** 572,578 ****
  			continue;
  		else if ( is_array( $cat_id ) )
  			$cat_id = $cat_id['term_id'];
! 		$cat_name = esc_html(stripslashes($cat_name));
  		$x->add( array(
  			'what' => 'link-category',
  			'id' => $cat_id,
--- 587,593 ----
  			continue;
  		else if ( is_array( $cat_id ) )
  			$cat_id = $cat_id['term_id'];
! 		$cat_name = esc_html( $cat_name );
  		$x->add( array(
  			'what' => 'link-category',
  			'id' => $cat_id,
***************
*** 651,657 ****
  	$tags = get_terms( $taxonomy, array( 'number' => 45, 'orderby' => 'count', 'order' => 'DESC' ) );
  
  	if ( empty( $tags ) )
! 		wp_die( isset( $tax->no_tagcloud ) ? $tax->no_tagcloud : __('No tags found!') );
  
  	if ( is_wp_error( $tags ) )
  		wp_die( $tags->get_error_message() );
--- 666,672 ----
  	$tags = get_terms( $taxonomy, array( 'number' => 45, 'orderby' => 'count', 'order' => 'DESC' ) );
  
  	if ( empty( $tags ) )
! 		wp_die( $tax->labels->not_found );
  
  	if ( is_wp_error( $tags ) )
  		wp_die( $tags->get_error_message() );
***************
*** 715,736 ****
  	check_ajax_referer( $action, '_ajax_nonce-replyto-comment' );
  
  	$comment_post_ID = (int) $_POST['comment_post_ID'];
! 	if ( !current_user_can( 'edit_post', $comment_post_ID ) )
  		wp_die( -1 );
  
! 	$status = $wpdb->get_var( $wpdb->prepare("SELECT post_status FROM $wpdb->posts WHERE ID = %d", $comment_post_ID) );
  
! 	if ( empty($status) )
  		wp_die( 1 );
! 	elseif ( in_array($status, array('draft', 'pending', 'trash') ) )
  		wp_die( __('ERROR: you are replying to a comment on a draft post.') );
  
  	$user = wp_get_current_user();
  	if ( $user->exists() ) {
  		$user_ID = $user->ID;
! 		$comment_author       = $wpdb->escape($user->display_name);
! 		$comment_author_email = $wpdb->escape($user->user_email);
! 		$comment_author_url   = $wpdb->escape($user->user_url);
  		$comment_content      = trim($_POST['content']);
  		if ( current_user_can( 'unfiltered_html' ) ) {
  			if ( wp_create_nonce( 'unfiltered-html-comment' ) != $_POST['_wp_unfiltered_html_comment'] ) {
--- 730,753 ----
  	check_ajax_referer( $action, '_ajax_nonce-replyto-comment' );
  
  	$comment_post_ID = (int) $_POST['comment_post_ID'];
! 	$post = get_post( $comment_post_ID );
! 	if ( ! $post )
  		wp_die( -1 );
  
! 	if ( !current_user_can( 'edit_post', $comment_post_ID ) )
! 		wp_die( -1 );
  
! 	if ( empty( $post->post_status ) )
  		wp_die( 1 );
! 	elseif ( in_array($post->post_status, array('draft', 'pending', 'trash') ) )
  		wp_die( __('ERROR: you are replying to a comment on a draft post.') );
  
  	$user = wp_get_current_user();
  	if ( $user->exists() ) {
  		$user_ID = $user->ID;
! 		$comment_author       = wp_slash( $user->display_name );
! 		$comment_author_email = wp_slash( $user->user_email );
! 		$comment_author_url   = wp_slash( $user->user_url );
  		$comment_content      = trim($_POST['content']);
  		if ( current_user_can( 'unfiltered_html' ) ) {
  			if ( wp_create_nonce( 'unfiltered-html-comment' ) != $_POST['_wp_unfiltered_html_comment'] ) {
***************
*** 903,908 ****
--- 920,926 ----
  		);
  		echo walk_nav_menu_tree( $menu_items, 0, (object) $args );
  	}
+ 	wp_die();
  }
  
  function wp_ajax_add_meta() {
***************
*** 924,930 ****
  			$_POST['post_type'] = $post->post_type;
  			$_POST['post_status'] = 'draft';
  			$now = current_time('timestamp', 1);
! 			$_POST['post_title'] = sprintf('Draft created on %s at %s', date(get_option('date_format'), $now), date(get_option('time_format'), $now));
  
  			if ( $pid = edit_post() ) {
  				if ( is_wp_error( $pid ) ) {
--- 942,948 ----
  			$_POST['post_type'] = $post->post_type;
  			$_POST['post_status'] = 'draft';
  			$now = current_time('timestamp', 1);
! 			$_POST['post_title'] = sprintf( __( 'Draft created on %1$s at %2$s' ), date( get_option( 'date_format' ), $now ), date( get_option( 'time_format' ), $now ) );
  
  			if ( $pid = edit_post() ) {
  				if ( is_wp_error( $pid ) ) {
***************
*** 956,963 ****
  		) );
  	} else { // Update?
  		$mid = (int) key( $_POST['meta'] );
! 		$key = stripslashes( $_POST['meta'][$mid]['key'] );
! 		$value = stripslashes( $_POST['meta'][$mid]['value'] );
  		if ( '' == trim($key) )
  			wp_die( __( 'Please provide a custom field name.' ) );
  		if ( '' == trim($value) )
--- 974,981 ----
  		) );
  	} else { // Update?
  		$mid = (int) key( $_POST['meta'] );
! 		$key = wp_unslash( $_POST['meta'][$mid]['key'] );
! 		$value = wp_unslash( $_POST['meta'][$mid]['value'] );
  		if ( '' == trim($key) )
  			wp_die( __( 'Please provide a custom field name.' ) );
  		if ( '' == trim($value) )
***************
*** 1024,1091 ****
  }
  
  function wp_ajax_autosave() {
- 	global $login_grace_period;
- 
  	define( 'DOING_AUTOSAVE', true );
  
! 	$nonce_age = check_ajax_referer( 'autosave', 'autosavenonce' );
  
  	$_POST['post_category'] = explode(",", $_POST['catslist']);
  	if ( $_POST['post_type'] == 'page' || empty($_POST['post_category']) )
  		unset($_POST['post_category']);
  
! 	$do_autosave = (bool) $_POST['autosave'];
! 	$do_lock = true;
! 
! 	$data = $alert = '';
! 	/* translators: draft saved date format, see http://php.net/date */
! 	$draft_saved_date_format = __('g:i:s a');
! 	/* translators: %s: date and time */
! 	$message = sprintf( __('Draft saved at %s.'), date_i18n( $draft_saved_date_format ) );
! 
  	$supplemental = array();
- 	if ( isset($login_grace_period) )
- 		$alert .= sprintf( __('Your login has expired. Please open a new browser window and <a href="%s" target="_blank">log in again</a>. '), add_query_arg( 'interim-login', 1, wp_login_url() ) );
- 
  	$id = $revision_id = 0;
  
! 	$post_ID = (int) $_POST['post_ID'];
! 	$_POST['ID'] = $post_ID;
! 	$post = get_post($post_ID);
  	if ( 'auto-draft' == $post->post_status )
  		$_POST['post_status'] = 'draft';
  
- 	if ( $last = wp_check_post_lock( $post->ID ) ) {
- 		$do_autosave = $do_lock = false;
- 
- 		$last_user = get_userdata( $last );
- 		$last_user_name = $last_user ? $last_user->display_name : __( 'Someone' );
- 		$data = __( 'Autosave disabled.' );
- 
- 		$supplemental['disable_autosave'] = 'disable';
- 		$alert .= sprintf( __( '%s is currently editing this article. If you update it, you will overwrite the changes.' ), esc_html( $last_user_name ) );
- 	}
- 
  	if ( 'page' == $post->post_type ) {
! 		if ( !current_user_can('edit_page', $post_ID) )
  			wp_die( __( 'You are not allowed to edit this page.' ) );
  	} else {
! 		if ( !current_user_can('edit_post', $post_ID) )
  			wp_die( __( 'You are not allowed to edit this post.' ) );
  	}
  
! 	if ( $do_autosave ) {
! 		// Drafts and auto-drafts are just overwritten by autosave
! 		if ( 'auto-draft' == $post->post_status || 'draft' == $post->post_status ) {
  			$id = edit_post();
! 		} else { // Non drafts are not overwritten. The autosave is stored in a special post revision.
  			$revision_id = wp_create_post_autosave( $post->ID );
  			if ( is_wp_error($revision_id) )
  				$id = $revision_id;
  			else
  				$id = $post->ID;
  		}
! 		$data = $message;
  	} else {
  		if ( ! empty( $_POST['auto_draft'] ) )
  			$id = 0; // This tells us it didn't actually save
--- 1042,1092 ----
  }
  
  function wp_ajax_autosave() {
  	define( 'DOING_AUTOSAVE', true );
  
! 	check_ajax_referer( 'autosave', 'autosavenonce' );
  
  	$_POST['post_category'] = explode(",", $_POST['catslist']);
  	if ( $_POST['post_type'] == 'page' || empty($_POST['post_category']) )
  		unset($_POST['post_category']);
  
! 	$data = '';
  	$supplemental = array();
  	$id = $revision_id = 0;
  
! 	$post_id = (int) $_POST['post_id'];
! 	$_POST['ID'] = $_POST['post_ID'] = $post_id;
! 	$post = get_post($post_id);
  	if ( 'auto-draft' == $post->post_status )
  		$_POST['post_status'] = 'draft';
  
  	if ( 'page' == $post->post_type ) {
! 		if ( !current_user_can('edit_page', $post->ID) )
  			wp_die( __( 'You are not allowed to edit this page.' ) );
  	} else {
! 		if ( !current_user_can('edit_post', $post->ID) )
  			wp_die( __( 'You are not allowed to edit this post.' ) );
  	}
  
! 	if ( ! empty( $_POST['autosave'] ) ) {
! 		if ( ! wp_check_post_lock( $post->ID ) && get_current_user_id() == $post->post_author && ( 'auto-draft' == $post->post_status || 'draft' == $post->post_status ) ) {
! 			// Drafts and auto-drafts are just overwritten by autosave for the same user if the post is not locked
  			$id = edit_post();
! 		} else {
! 			// Non drafts or other users drafts are not overwritten. The autosave is stored in a special post revision for each user.
  			$revision_id = wp_create_post_autosave( $post->ID );
  			if ( is_wp_error($revision_id) )
  				$id = $revision_id;
  			else
  				$id = $post->ID;
  		}
! 
! 		if ( ! is_wp_error($id) ) {
! 			/* translators: draft saved date format, see http://php.net/date */
! 			$draft_saved_date_format = __('g:i:s a');
! 			/* translators: %s: date and time */
! 			$data = sprintf( __('Draft saved at %s.'), date_i18n( $draft_saved_date_format ) );
! 		}
  	} else {
  		if ( ! empty( $_POST['auto_draft'] ) )
  			$id = 0; // This tells us it didn't actually save
***************
*** 1093,1124 ****
  			$id = $post->ID;
  	}
  
! 	if ( $do_lock && empty( $_POST['auto_draft'] ) && $id && is_numeric( $id ) ) {
! 		$lock_result = wp_set_post_lock( $id );
! 		$supplemental['active-post-lock'] = implode( ':', $lock_result );
! 	}
! 
! 	if ( $nonce_age == 2 ) {
! 		$supplemental['replace-autosavenonce'] = wp_create_nonce('autosave');
! 		$supplemental['replace-getpermalinknonce'] = wp_create_nonce('getpermalink');
! 		$supplemental['replace-samplepermalinknonce'] = wp_create_nonce('samplepermalink');
! 		$supplemental['replace-closedpostboxesnonce'] = wp_create_nonce('closedpostboxes');
! 		$supplemental['replace-_ajax_linking_nonce'] = wp_create_nonce( 'internal-linking' );
! 		if ( $id ) {
! 			if ( $_POST['post_type'] == 'post' )
! 				$supplemental['replace-_wpnonce'] = wp_create_nonce('update-post_' . $id);
! 			elseif ( $_POST['post_type'] == 'page' )
! 				$supplemental['replace-_wpnonce'] = wp_create_nonce('update-page_' . $id);
! 		}
! 	}
! 
! 	if ( ! empty($alert) )
! 		$supplemental['alert'] = $alert;
! 
  	$x = new WP_Ajax_Response( array(
  		'what' => 'autosave',
  		'id' => $id,
! 		'data' => $id ? $data : '',
  		'supplemental' => $supplemental
  	) );
  	$x->send();
--- 1094,1104 ----
  			$id = $post->ID;
  	}
  
! 	// @todo Consider exposing any errors, rather than having 'Saving draft...'
  	$x = new WP_Ajax_Response( array(
  		'what' => 'autosave',
  		'id' => $id,
! 		'data' => $data,
  		'supplemental' => $supplemental
  	) );
  	$x->send();
***************
*** 1226,1232 ****
  	$args = array();
  
  	if ( isset( $_POST['search'] ) )
! 		$args['s'] = stripslashes( $_POST['search'] );
  	$args['pagenum'] = ! empty( $_POST['page'] ) ? absint( $_POST['page'] ) : 1;
  
  	require(ABSPATH . WPINC . '/class-wp-editor.php');
--- 1206,1212 ----
  	$args = array();
  
  	if ( isset( $_POST['search'] ) )
! 		$args['s'] = wp_unslash( $_POST['search'] );
  	$args['pagenum'] = ! empty( $_POST['page'] ) ? absint( $_POST['page'] ) : 1;
  
  	require(ABSPATH . WPINC . '/class-wp-editor.php');
***************
*** 1327,1333 ****
  	$data = &$_POST;
  
  	$post = get_post( $post_ID, ARRAY_A );
! 	$post = add_magic_quotes($post); //since it is from db
  
  	$data['content'] = $post['post_content'];
  	$data['excerpt'] = $post['post_excerpt'];
--- 1307,1313 ----
  	$data = &$_POST;
  
  	$post = get_post( $post_ID, ARRAY_A );
! 	$post = wp_slash($post); //since it is from db
  
  	$data['content'] = $post['post_content'];
  	$data['excerpt'] = $post['post_excerpt'];
***************
*** 1349,1354 ****
--- 1329,1340 ----
  	if ( empty($data['ping_status']) )
  		$data['ping_status'] = 'closed';
  
+ 	// Hack: wp_unique_post_slug() doesn't work for drafts, so we will fake that our post is published.
+ 	if ( ! empty( $data['post_name'] ) && in_array( $post['post_status'], array( 'draft', 'pending' ) ) ) {
+ 		$post['post_status'] = 'publish';
+ 		$data['post_name'] = wp_unique_post_slug( $data['post_name'], $post['ID'], $post['post_status'], $post['post_type'], $post['post_parent'] );
+ 	}
+ 
  	// update the post
  	edit_post();
  
***************
*** 1412,1418 ****
  		$parent = $parent_tag->parent;
  		$level++;
  	}
! 	echo $wp_list_table->single_row( $tag, $level );
  	wp_die();
  }
  
--- 1398,1404 ----
  		$parent = $parent_tag->parent;
  		$level++;
  	}
! 	$wp_list_table->single_row( $tag, $level );
  	wp_die();
  }
  
***************
*** 1424,1430 ****
  	$post_types = get_post_types( array( 'public' => true ), 'objects' );
  	unset( $post_types['attachment'] );
  
! 	$s = stripslashes( $_POST['ps'] );
  	$searchand = $search = '';
  	$args = array(
  		'post_type' => array_keys( $post_types ),
--- 1410,1416 ----
  	$post_types = get_post_types( array( 'public' => true ), 'objects' );
  	unset( $post_types['attachment'] );
  
! 	$s = wp_unslash( $_POST['ps'] );
  	$searchand = $search = '';
  	$args = array(
  		'post_type' => array_keys( $post_types ),
***************
*** 1776,1782 ****
  	if ( $active_lock[1] != get_current_user_id() )
  		wp_die( 0 );
  
! 	$new_lock = ( time() - apply_filters( 'wp_check_post_lock_window', AUTOSAVE_INTERVAL * 2 ) + 5 ) . ':' . $active_lock[1];
  	update_post_meta( $post_id, '_edit_lock', $new_lock, implode( ':', $active_lock ) );
  	wp_die( 1 );
  }
--- 1762,1768 ----
  	if ( $active_lock[1] != get_current_user_id() )
  		wp_die( 0 );
  
! 	$new_lock = ( time() - apply_filters( 'wp_check_post_lock_window', 120 ) + 5 ) . ':' . $active_lock[1];
  	update_post_meta( $post_id, '_edit_lock', $new_lock, implode( ':', $active_lock ) );
  	wp_die( 1 );
  }
***************
*** 1888,1898 ****
  		$post['post_content'] = $changes['description'];
  
  	if ( isset( $changes['alt'] ) ) {
! 		$alt = get_post_meta( $id, '_wp_attachment_image_alt', true );
! 		$new_alt = stripslashes( $changes['alt'] );
! 		if ( $alt != $new_alt ) {
! 			$new_alt = wp_strip_all_tags( $new_alt, true );
! 			update_post_meta( $id, '_wp_attachment_image_alt', addslashes( $new_alt ) );
  		}
  	}
  
--- 1874,1883 ----
  		$post['post_content'] = $changes['description'];
  
  	if ( isset( $changes['alt'] ) ) {
! 		$alt = wp_unslash( $changes['alt'] );
! 		if ( $alt != get_post_meta( $id, '_wp_attachment_image_alt', true ) ) {
! 			$alt = wp_strip_all_tags( $alt, true );
! 			update_post_meta( $id, '_wp_attachment_image_alt', wp_slash( $alt ) );
  		}
  	}
  
***************
*** 1989,1995 ****
  function wp_ajax_send_attachment_to_editor() {
  	check_ajax_referer( 'media-send-to-editor', 'nonce' );
  
! 	$attachment = stripslashes_deep( $_POST['attachment'] );
  
  	$id = intval( $attachment['id'] );
  
--- 1974,1980 ----
  function wp_ajax_send_attachment_to_editor() {
  	check_ajax_referer( 'media-send-to-editor', 'nonce' );
  
! 	$attachment = wp_unslash( $_POST['attachment'] );
  
  	$id = intval( $attachment['id'] );
  
***************
*** 2015,2021 ****
  		$html = '<a href="' . esc_url( $url ) . '"' . $rel . '>' . $html . '</a>';
  	}
  
! 	remove_filter( 'media_send_to_editor', 'image_media_send_to_editor', 10, 3 );
  
  	if ( 'image' === substr( $post->post_mime_type, 0, 5 ) ) {
  		$align = isset( $attachment['align'] ) ? $attachment['align'] : 'none';
--- 2000,2006 ----
  		$html = '<a href="' . esc_url( $url ) . '"' . $rel . '>' . $html . '</a>';
  	}
  
! 	remove_filter( 'media_send_to_editor', 'image_media_send_to_editor' );
  
  	if ( 'image' === substr( $post->post_mime_type, 0, 5 ) ) {
  		$align = isset( $attachment['align'] ) ? $attachment['align'] : 'none';
***************
*** 2024,2029 ****
--- 2009,2016 ----
  		$caption = isset( $attachment['post_excerpt'] ) ? $attachment['post_excerpt'] : '';
  		$title = ''; // We no longer insert title tags into <img> tags, as they are redundant.
  		$html = get_image_send_to_editor( $id, $caption, $title, $align, $url, (bool) $rel, $size, $alt );
+ 	} elseif ( 'video' === substr( $post->post_mime_type, 0, 5 ) || 'audio' === substr( $post->post_mime_type, 0, 5 )  ) {
+ 		$html = stripslashes_deep( $_POST['html'] );
  	}
  
  	$html = apply_filters( 'media_send_to_editor', $html, $id, $attachment );
***************
*** 2044,2050 ****
  function wp_ajax_send_link_to_editor() {
  	check_ajax_referer( 'media-send-to-editor', 'nonce' );
  
! 	if ( ! $src = stripslashes( $_POST['src'] ) )
  		wp_send_json_error();
  
  	if ( ! strpos( $src, '://' ) )
--- 2031,2037 ----
  function wp_ajax_send_link_to_editor() {
  	check_ajax_referer( 'media-send-to-editor', 'nonce' );
  
! 	if ( ! $src = wp_unslash( $_POST['src'] ) )
  		wp_send_json_error();
  
  	if ( ! strpos( $src, '://' ) )
***************
*** 2053,2059 ****
  	if ( ! $src = esc_url_raw( $src ) )
  		wp_send_json_error();
  
! 	if ( ! $title = trim( stripslashes( $_POST['title'] ) ) )
  		$title = wp_basename( $src );
  
  	$html = '';
--- 2040,2046 ----
  	if ( ! $src = esc_url_raw( $src ) )
  		wp_send_json_error();
  
! 	if ( ! $title = trim( wp_unslash( $_POST['title'] ) ) )
  		$title = wp_basename( $src );
  
  	$html = '';
***************
*** 2070,2072 ****
--- 2057,2125 ----
  
  	wp_send_json_success( $html );
  }
+ 
+ /**
+  * Heartbeat API (experimental)
+  *
+  * Runs when the user is logged in.
+  */
+ function wp_ajax_heartbeat() {
+ 	if ( empty( $_POST['_nonce'] ) )
+ 		wp_send_json_error();
+ 
+ 	$response = array();
+ 
+ 	if ( false === wp_verify_nonce( $_POST['_nonce'], 'heartbeat-nonce' ) ) {
+ 		// User is logged in but nonces have expired.
+ 		$response['nonces_expired'] = true;
+ 		wp_send_json($response);
+ 	}
+ 
+ 	// screen_id is the same as $current_screen->id and the JS global 'pagenow'
+ 	if ( ! empty($_POST['screen_id']) )
+ 		$screen_id = sanitize_key($_POST['screen_id']);
+ 	else
+ 		$screen_id = 'front';
+ 
+ 	if ( ! empty($_POST['data']) ) {
+ 		$data = (array) $_POST['data'];
+ 		$response = apply_filters( 'heartbeat_received', $response, $data, $screen_id );
+ 	}
+ 
+ 	$response = apply_filters( 'heartbeat_send', $response, $screen_id );
+ 
+ 	// Allow the transport to be replaced with long-polling easily
+ 	do_action( 'heartbeat_tick', $response, $screen_id );
+ 
+ 	// Send the current time according to the server
+ 	$response['server_time'] = time();
+ 
+ 	wp_send_json($response);
+ }
+ 
+ function wp_ajax_get_revision_diffs() {
+ 	require ABSPATH . 'wp-admin/includes/revision.php';
+ 
+ 	if ( ! $post = get_post( (int) $_REQUEST['post_id'] ) )
+ 		wp_send_json_error();
+ 
+ 	if ( ! current_user_can( 'read_post', $post->ID ) )
+ 		wp_send_json_error();
+ 
+ 	// Really just pre-loading the cache here.
+ 	if ( ! $revisions = wp_get_post_revisions( $post->ID, array( 'check_enabled' => false ) ) )
+ 		wp_send_json_error();
+ 
+ 	$return = array();
+ 	@set_time_limit( 0 );
+ 
+ 	foreach ( $_REQUEST['compare'] as $compare_key ) {
+ 		list( $compare_from, $compare_to ) = explode( ':', $compare_key ); // from:to
+ 
+ 		$return[] = array(
+ 			'id' => $compare_key,
+ 			'fields' => wp_get_revision_ui_diff( $post, $compare_from, $compare_to ),
+ 		);
+ 	}
+ 	wp_send_json_success( $return );
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/bookmark.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/bookmark.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/bookmark.php	2012-11-26 18:20:27.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/bookmark.php	2013-03-01 11:00:25.000000000 -0600
***************
*** 55,66 ****
  function get_default_link_to_edit() {
  	$link = new stdClass;
  	if ( isset( $_GET['linkurl'] ) )
! 		$link->link_url = esc_url( $_GET['linkurl'] );
  	else
  		$link->link_url = '';
  
  	if ( isset( $_GET['name'] ) )
! 		$link->link_name = esc_attr( $_GET['name'] );
  	else
  		$link->link_name = '';
  
--- 55,66 ----
  function get_default_link_to_edit() {
  	$link = new stdClass;
  	if ( isset( $_GET['linkurl'] ) )
! 		$link->link_url = esc_url( wp_unslash( $_GET['linkurl'] ) );
  	else
  		$link->link_url = '';
  
  	if ( isset( $_GET['name'] ) )
! 		$link->link_name = esc_attr( wp_unslash( $_GET['name'] ) );
  	else
  		$link->link_name = '';
  
***************
*** 137,143 ****
  	$linkdata = wp_parse_args( $linkdata, $defaults );
  	$linkdata = sanitize_bookmark( $linkdata, 'db' );
  
! 	extract( stripslashes_deep( $linkdata ), EXTR_SKIP );
  
  	$update = false;
  
--- 137,143 ----
  	$linkdata = wp_parse_args( $linkdata, $defaults );
  	$linkdata = sanitize_bookmark( $linkdata, 'db' );
  
! 	extract( wp_unslash( $linkdata ), EXTR_SKIP );
  
  	$update = false;
  
***************
*** 251,257 ****
  	$link = get_bookmark( $link_id, ARRAY_A );
  
  	// Escape data pulled from DB.
! 	$link = add_magic_quotes( $link );
  
  	// Passed link category list overwrites existing category list if not empty.
  	if ( isset( $linkdata['link_category'] ) && is_array( $linkdata['link_category'] )
--- 251,257 ----
  	$link = get_bookmark( $link_id, ARRAY_A );
  
  	// Escape data pulled from DB.
! 	$link = wp_slash( $link );
  
  	// Passed link category list overwrites existing category list if not empty.
  	if ( isset( $linkdata['link_category'] ) && is_array( $linkdata['link_category'] )
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp.php	2012-03-28 21:15:06.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp.php	2013-02-15 10:26:46.000000000 -0600
***************
*** 9,15 ****
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL License http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
--- 9,15 ----
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp-pure.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp-pure.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp-pure.php	2008-08-14 01:30:38.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp-pure.php	2013-02-15 10:26:46.000000000 -0600
***************
*** 9,15 ****
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL License http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
--- 9,15 ----
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
***************
*** 23,29 ****
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL License http://www.opensource.org/licenses/lgpl-license.html
   */
  class ftp extends ftp_base {
  
--- 23,29 ----
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL http://www.opensource.org/licenses/lgpl-license.html
   */
  class ftp extends ftp_base {
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp-sockets.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp-sockets.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/class-ftp-sockets.php	2008-08-14 01:30:38.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/class-ftp-sockets.php	2013-02-15 10:26:46.000000000 -0600
***************
*** 9,15 ****
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL License http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
--- 9,15 ----
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL http://www.opensource.org/licenses/lgpl-license.html
   */
  
  /**
***************
*** 23,29 ****
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL License http://www.opensource.org/licenses/lgpl-license.html
   */
  class ftp extends ftp_base {
  
--- 23,29 ----
   * @copyright Alexey Dotsenko
   * @author Alexey Dotsenko
   * @link http://www.phpclasses.org/browse/package/1743.html Site
!  * @license LGPL http://www.opensource.org/licenses/lgpl-license.html
   */
  class ftp extends ftp_base {
  
